version: '3.9'

services:

    # Used to provide Tor Hidden Services 
    tor-router-debian:
        image: tor-router-debian:1.1
        build: 
            context: ./tor-router/image/tor-router-debian
            # network: host
            # args:
                # HTTP_PROXY: http:/127.0.0.1:8118
                # HTTPS_PROXY: http:/127.0.0.1:8118
                # NO_PROXY: 127.0.0.1,127.0.0.0/8
        restart: always
        healthcheck:
          test: "/bin/bash -c \"if [ ! -f /tmp/health.txt ]; then touch /tmp/health.txt && curl  -S -s --connect-timeout 240 --retry 5 --retry-delay 30 https://check.torproject.org/api/ip | grep :true, || exit 1 ; fi\""
          interval: 30s
          timeout: 10m
          retries: 5
          start_period: 10s
        privileged: true
        cap_add:
            - NET_ADMIN
        environment:
            - TOR_ROUTER_HOME=/etc/tor
            - TOR_CONFIG_FILE=/etc/tor/torrc
        volumes:
            # out .onion name is here : ./data/tor/hidden_service/hostname
            - ./data/tor:/etc/tor

    mariadb:
        image: mariadb:1.0
        build: 
            context: ./image/mariadb
        network_mode: service:tor-router-debian
        # command: sh -c "mysqld"
        # command: sh -c "bash"
        volumes:
            - ./data/mariadb_config:/etc/mysql
            - ./data/mariadb_data:/var/lib/mysql
    
    php-fpm:
        image: php-fpm:1.0
        build: 
            context: ./image/php-fpm
        # network_mode: container:lamp_tor-router-debian_1
        network_mode: service:tor-router-debian
        command: sh -c "php-fpm7.4 -F -R -O"
        # command: sh -c "bash"
        # /etc/php/7.4/fpm/php-fpm.conf
        # /sbin:/usr/sbin:/bin:/usr/bin
        # expose:
            # - 9000
        # environment:
            # APP_ENV: prod
            # TIMEZONE: "Europe/Brussels"
        # volumes_from:
            # - application
        volumes:
            - ./data/php_config:/etc/php
            - ./data/html:/var/www/html
            
    apache:
        image: apache:1.0
        build: 
            context: ./image/apache
        # depends_on:
            # tor-router-debian:
                # condition: service_healthy
        # network_mode: service:tor-router-debian
        # network_mode: container:tor-router_tor-router-debian_1
        # network_mode: container:lamp_tor-router-debian_1
        network_mode: service:tor-router-debian
        # command: sh -c "curl --retry-connrefused --connect-timeout 240 --retry 20 --retry-delay 5 -S -s https://check.torproject.org/api/ip | grep :true"
        command: sh -c "sudo a2enmod rewrite && /usr/sbin/apache2ctl -D FOREGROUND"
        # ports:
          # - "80:80"
        # expose:
          # - "80"
        # environment:
        volumes:
            - ./data/html:/var/www/html
            # - ./data/etc_apache2_default_config:/etc/apache2:ro
            - ./data/etc_apache2_config:/etc/apache2
            
       